#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef HttpDlgH
#define HttpDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <HttpProt.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Tabs.hpp>
#include "explbtn.hpp"
//---------------------------------------------------------------------------
bool __fastcall GetRemailerStats(TForm *parent, bool attended=true);

class THttpForm : public TForm
{
__published:	// IDE-managed Components
	THttpCli *HttpCli1;
  TPanel *Panel2;
  TProgressBar *ProgressBar1;
  TButton *GetBtn;
  TButton *CancelBtn;
  TTimer *Timer1;
  TTimer *Timer2;
   TPanel *Panel1;
   TPageControl *PageControl1;
   TTabSheet *TabSheet1;
   TGroupBox *MixmasterGrp;
   TCheckBox *MTyp2Box;
   TCheckBox *MRingBox;
   TCheckBox *MListBox;
   TGroupBox *CyberpunkGrp;
   TCheckBox *CRingBox;
   TCheckBox *CListBox;
   TButton *UrlsBtn;
   TTabSheet *TabSheet2;
   TLabel *Label2;
   TLabel *Label3;
   TLabel *Label4;
   TLabel *Label5;
   TLabel *Label6;
   TEdit *ProxyHostEdit;
   TEdit *ProxyPortEdit;
   TEdit *ProxyPswdEdit;
   TEdit *ProxyUserEdit;
   TCheckBox *ProxyPswdBox;
   TTabSheet *TabSheet3;
   TMemo *DocMemo;
   TTabSet *TabSet;
   TLabel *Label1;
  TButton *OkBtn;
  TRichEdit *RichEdit1;
  TLabel *Label7;
	void __fastcall GetBtnClick(TObject *Sender);
	void __fastcall HttpCli1DocBegin(TObject *Sender);
	void __fastcall HttpCli1DocEnd(TObject *Sender);
	void __fastcall HttpCli1RequestDone(TObject *Sender, THttpRequest RqType,
   	WORD Error);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len);
  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall ProxyPswdBoxClick(TObject *Sender);
  void __fastcall PageControl1Changing(TObject *Sender, bool &AllowChange);
  void __fastcall Timer2Timer(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall UrlsBtnClick(TObject *Sender);
   void __fastcall TabSetChange(TObject *Sender, int NewTab, bool &AllowChange);
   void __fastcall FormResize(TObject *Sender);
private:	// User declarations
public:		// User declarations
   TStrings *Tabs;
   AnsiString CurDoc;
   TCheckBox *CurBox;
   double BytesTotal;
   long BytesReceived;
   AnsiString Cap,Http,
      MListURL,MRingURL,MTyp2URL,
      CListURL,CRingURL;
   bool Attended,Cancelled;
   __fastcall THttpForm(TComponent* Owner);
   void __fastcall LoadHttpInfo();
   void __fastcall StoreHttpInfo();
   void __fastcall SaveStatistics();
   void __fastcall InitCheckmarks();
   bool __fastcall Execute(bool attended);
   void __fastcall GetAppURLs();
   AnsiString __fastcall GetDefaultURL(AnsiString &path);
   bool __fastcall GetStatistics(AnsiString &forURL, TCheckBox *Box, AnsiString &Doc);
   void __fastcall ResetCheckboxes();
   // error checking
   bool __fastcall ErrorMixmasterDocs(TStrings *ErrLog);
   bool __fastcall ErrorCyberpunkDocs(TStrings *ErrLog);
   bool __fastcall GetDoc(TStrings* Doc, AnsiString &Docname);
   bool __fastcall GotDoc(AnsiString &Docname);
   int __fastcall MlistTxtErr(TStrings *Doc, TStrings *ErrLog);
   int __fastcall PubringMixErr(TStrings *Doc, TStrings *ErrLog);
   int __fastcall Type2ListErr(TStrings *Doc, TStrings *ErrLog);
};
//---------------------------------------------------------------------------
extern THttpForm *HttpForm;
//---------------------------------------------------------------------------
#endif
