//---------------------------------------------------------------------------
#ifndef MBoxWinH
#define MBoxWinH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "Grids.hpp"
#include <vcl\Buttons.hpp>
#include <vcl\Menus.hpp>
#include "global.h"
//---------------------------------------------------------------------------
class TMailboxWin;

TMailboxWin* __fastcall OpenMailbox(AnsiString &BoxName);
TMailboxWin* __fastcall FindOpenMailbox(AnsiString &BoxName);
AnsiString __fastcall CreateMailbox(AnsiString &BoxName=AnsiString("")); // empty string brings up intertactive dialog
//bool __fastcall DeleteEntireMailbox(HWND HParent, AnsiString &BoxName);  //
void __fastcall DelMailboxPos(AnsiString &BoxName); // delete message index position
void __fastcall SetMailboxPos(AnsiString &BoxName, long position);
void __fastcall DelMailbox(AnsiString &BoxName);
bool __fastcall DelMenubox(AnsiString &BoxName);
void __fastcall AddMenubox(AnsiString &BoxName);
bool __fastcall IsMenubox(AnsiString &BoxName);
bool __fastcall MailboxExists(AnsiString &BoxName);
// Selected, below, is the array of bools from currently open index window
// alternatively it can be NULL, indicating delete/transfer ALL
long __fastcall TransferMessages(AnsiString &Boxname, bool *Selected,
   AnsiString &NewBoxname);
long __fastcall DelMessages(AnsiString &Boxname, bool *Selected);

const AnsiString HeaderText = "Date Who Subject S";
//const int SubjectCol = 2;

class TMailGrid : public TDrawGrid
{
private:
protected:
   void __fastcall DrawCell(long ACol, long ARow, const Windows::TRect &Rect,
      TGridDrawState State);
   void __fastcall KeyDown(unsigned short &Key, TShiftState Shift);
   void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift,
      int X, int Y);
   void __fastcall DblClick();
public:
   long Anchor;
   bool *Selected;
   AnsiString Mailbox;
   TStringList *MailList;
   TImageList *ImageList;
   int LastLeftCol;
   __fastcall virtual TMailGrid(TComponent *Owner);
   __fastcall virtual TMailGrid(TComponent *Owner, AnsiString &BoxName);
   __fastcall virtual ~TMailGrid();
   AnsiString __fastcall BoxName() { return Mailbox; };
   AnsiString __fastcall MessageSubject(AnsiString &IndexStr);
   AnsiString __fastcall MessageDate(AnsiString &IndexStr);
   AnsiString __fastcall MessageWho(AnsiString &IndexStr);
   void __fastcall OpenIndex();
   void __fastcall CloseIndex();
   void __fastcall RefreshIndex();
   void __fastcall SetBoxPos(int pos);
   int  __fastcall GetBoxPos();
   long __fastcall TransferSelected(AnsiString &MailBox);
   long __fastcall DeleteSelected();
   long __fastcall ClearSelected();
   void __fastcall SetSelected(long Anchor, long ToRow=-1);
   long __fastcall OpenSelected();
   long __fastcall GridRow(long Row); // test for validity of row--not too low or high
   long __fastcall SelCount();
   void __fastcall SelectAll();
  //void __fastcall TopLeftChanged(TObject *Sender);
};

class TMailboxWin : public TForm
{
__published:	// IDE-managed Components
	TPopupMenu *PopupMenu;
  TMenuItem *PopupTransferItem;
  TMenuItem *PopupDeleteItem;
	TMenuItem *PopupMailboxMenuItem;
	TMenuItem *N1;
	TMenuItem *PopupDeleteMailboxItem;
	TMenuItem *N2;
  TMenuItem *PopupOpenItem;
  TImageList *ImageList1;
  TMainMenu *MainMenu1;
  TMenuItem *Edit1;
  TMenuItem *Undo1;
  TMenuItem *N3;
  TMenuItem *Cut1;
  TMenuItem *Copy1;
  TMenuItem *Paste1;
  TMenuItem *N4;
  TMenuItem *EditSelectAllItem;
  TMenuItem *N5;
  TMenuItem *PopSelectAllItem;
	void __fastcall FormResize(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall PopupDeleteItemClick(TObject *Sender);
	void __fastcall PopupMailboxMenuItemClick(TObject *Sender);
	void __fastcall PopupTransferItemClick(TObject *Sender);
	void __fastcall PopupRefreshItemClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall PopupMenuPopup(TObject *Sender);
  void __fastcall PopupOpenItemClick(TObject *Sender);
  void __fastcall PopupDeleteMailboxItemClick(TObject *Sender);
  void __fastcall EditSelectAllItemClick(TObject *Sender);
  void __fastcall PopSelectAllItemClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  TMailGrid *MailGrid;
	__fastcall virtual TMailboxWin(TComponent* Owner);
	__fastcall virtual TMailboxWin(TComponent* Owner, AnsiString &BoxName);
  __fastcall virtual ~TMailboxWin();
  AnsiString __fastcall BoxName() { return Caption; }
  long __fastcall GoNewMessages();
  void __fastcall RefreshIndex();
};
//---------------------------------------------------------------------------
extern TMailboxWin *MailboxWin;
//---------------------------------------------------------------------------
#endif
